// Code generated by protoc-gen-go.
// source: flow/flow.proto
// DO NOT EDIT!

/*
Package flow is a generated protocol buffer package.

It is generated from these files:
	flow/flow.proto
	flow/set.proto
	flow/request.proto

It has these top-level messages:
	FlowLayer
	FlowMetric
	Flow
	FlowSet
	FlowSearchReply
*/
package flow

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type FlowProtocol int32

const (
	FlowProtocol_ETHERNET FlowProtocol = 0
	FlowProtocol_IPV4     FlowProtocol = 1
	FlowProtocol_TCPPORT  FlowProtocol = 2
	FlowProtocol_UDPPORT  FlowProtocol = 3
	FlowProtocol_SCTPPORT FlowProtocol = 4
	FlowProtocol_IPV6     FlowProtocol = 5
)

var FlowProtocol_name = map[int32]string{
	0: "ETHERNET",
	1: "IPV4",
	2: "TCPPORT",
	3: "UDPPORT",
	4: "SCTPPORT",
	5: "IPV6",
}
var FlowProtocol_value = map[string]int32{
	"ETHERNET": 0,
	"IPV4":     1,
	"TCPPORT":  2,
	"UDPPORT":  3,
	"SCTPPORT": 4,
	"IPV6":     5,
}

func (x FlowProtocol) String() string {
	return proto.EnumName(FlowProtocol_name, int32(x))
}
func (FlowProtocol) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type FlowLayer struct {
	Protocol FlowProtocol `protobuf:"varint,1,opt,name=Protocol,enum=flow.FlowProtocol" json:"Protocol,omitempty"`
	A        string       `protobuf:"bytes,3,opt,name=A" json:"A,omitempty"`
	B        string       `protobuf:"bytes,4,opt,name=B" json:"B,omitempty"`
	ID       int64        `protobuf:"varint,5,opt,name=ID" json:"ID"`
}

func (m *FlowLayer) Reset()                    { *m = FlowLayer{} }
func (m *FlowLayer) String() string            { return proto.CompactTextString(m) }
func (*FlowLayer) ProtoMessage()               {}
func (*FlowLayer) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *FlowLayer) GetProtocol() FlowProtocol {
	if m != nil {
		return m.Protocol
	}
	return FlowProtocol_ETHERNET
}

func (m *FlowLayer) GetA() string {
	if m != nil {
		return m.A
	}
	return ""
}

func (m *FlowLayer) GetB() string {
	if m != nil {
		return m.B
	}
	return ""
}

func (m *FlowLayer) GetID() int64 {
	if m != nil {
		return m.ID
	}
	return 0
}

type FlowMetric struct {
	ABPackets int64 `protobuf:"varint,2,opt,name=ABPackets" json:"ABPackets"`
	ABBytes   int64 `protobuf:"varint,3,opt,name=ABBytes" json:"ABBytes"`
	BAPackets int64 `protobuf:"varint,4,opt,name=BAPackets" json:"BAPackets"`
	BABytes   int64 `protobuf:"varint,5,opt,name=BABytes" json:"BABytes"`
}

func (m *FlowMetric) Reset()                    { *m = FlowMetric{} }
func (m *FlowMetric) String() string            { return proto.CompactTextString(m) }
func (*FlowMetric) ProtoMessage()               {}
func (*FlowMetric) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *FlowMetric) GetABPackets() int64 {
	if m != nil {
		return m.ABPackets
	}
	return 0
}

func (m *FlowMetric) GetABBytes() int64 {
	if m != nil {
		return m.ABBytes
	}
	return 0
}

func (m *FlowMetric) GetBAPackets() int64 {
	if m != nil {
		return m.BAPackets
	}
	return 0
}

func (m *FlowMetric) GetBABytes() int64 {
	if m != nil {
		return m.BABytes
	}
	return 0
}

type Flow struct {
	// Flow Universally Unique IDentifier
	// flow.UUID is unique in the universe, as it should be used as a key of an
	// hashtable. By design 2 different flows, their UUID are always different.
	// flow.UUID can be used as Database Index.
	UUID       string `protobuf:"bytes,1,opt,name=UUID" json:"UUID,omitempty"`
	LayersPath string `protobuf:"bytes,2,opt,name=LayersPath" json:"LayersPath,omitempty"`
	// Application is the last layer which is not a payload.
	Application string `protobuf:"bytes,3,opt,name=Application" json:"Application,omitempty"`
	// Data Flow info
	Link      *FlowLayer `protobuf:"bytes,20,opt,name=Link" json:"Link,omitempty"`
	Network   *FlowLayer `protobuf:"bytes,21,opt,name=Network" json:"Network,omitempty"`
	Transport *FlowLayer `protobuf:"bytes,22,opt,name=Transport" json:"Transport,omitempty"`
	// Data Flow Metric info from the 1st layer
	// amount of data between two updates
	LastUpdateMetric *FlowMetric `protobuf:"bytes,31,opt,name=LastUpdateMetric" json:"LastUpdateMetric,omitempty"`
	// Total amount of data for the whole flow duration
	Metric          *FlowMetric `protobuf:"bytes,32,opt,name=Metric" json:"Metric,omitempty"`
	Start           int64       `protobuf:"varint,10,opt,name=Start" json:"Start"`
	Last            int64       `protobuf:"varint,11,opt,name=Last" json:"Last"`
	LastUpdateStart int64       `protobuf:"varint,12,opt,name=LastUpdateStart" json:"LastUpdateStart"`
	LastUpdateLast  int64       `protobuf:"varint,13,opt,name=LastUpdateLast" json:"LastUpdateLast"`
	// Flow Tracking IDentifier, from 1st packet bytes
	// flow.TrackingID could be used to identify an unique flow whatever it has
	// been captured on the infrastructure. flow.TrackingID is calculated from
	// the bytes of the first packet of his session.
	// flow.TrackingID can be used as a Tag.
	TrackingID   string `protobuf:"bytes,50,opt,name=TrackingID" json:"TrackingID,omitempty"`
	L3TrackingID string `protobuf:"bytes,51,opt,name=L3TrackingID" json:"L3TrackingID,omitempty"`
	// Flow Parent UUID is used as reference to the parent flow
	// Flow.ParentUUID is the same value that point to his parent flow.UUID
	ParentUUID string `protobuf:"bytes,6,opt,name=ParentUUID" json:"ParentUUID"`
	// Topology info
	NodeTID  string `protobuf:"bytes,33,opt,name=NodeTID" json:"NodeTID,omitempty"`
	ANodeTID string `protobuf:"bytes,34,opt,name=ANodeTID" json:"ANodeTID,omitempty"`
	BNodeTID string `protobuf:"bytes,35,opt,name=BNodeTID" json:"BNodeTID,omitempty"`
}

func (m *Flow) Reset()                    { *m = Flow{} }
func (m *Flow) String() string            { return proto.CompactTextString(m) }
func (*Flow) ProtoMessage()               {}
func (*Flow) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *Flow) GetUUID() string {
	if m != nil {
		return m.UUID
	}
	return ""
}

func (m *Flow) GetLayersPath() string {
	if m != nil {
		return m.LayersPath
	}
	return ""
}

func (m *Flow) GetApplication() string {
	if m != nil {
		return m.Application
	}
	return ""
}

func (m *Flow) GetLink() *FlowLayer {
	if m != nil {
		return m.Link
	}
	return nil
}

func (m *Flow) GetNetwork() *FlowLayer {
	if m != nil {
		return m.Network
	}
	return nil
}

func (m *Flow) GetTransport() *FlowLayer {
	if m != nil {
		return m.Transport
	}
	return nil
}

func (m *Flow) GetLastUpdateMetric() *FlowMetric {
	if m != nil {
		return m.LastUpdateMetric
	}
	return nil
}

func (m *Flow) GetMetric() *FlowMetric {
	if m != nil {
		return m.Metric
	}
	return nil
}

func (m *Flow) GetStart() int64 {
	if m != nil {
		return m.Start
	}
	return 0
}

func (m *Flow) GetLast() int64 {
	if m != nil {
		return m.Last
	}
	return 0
}

func (m *Flow) GetLastUpdateStart() int64 {
	if m != nil {
		return m.LastUpdateStart
	}
	return 0
}

func (m *Flow) GetLastUpdateLast() int64 {
	if m != nil {
		return m.LastUpdateLast
	}
	return 0
}

func (m *Flow) GetTrackingID() string {
	if m != nil {
		return m.TrackingID
	}
	return ""
}

func (m *Flow) GetL3TrackingID() string {
	if m != nil {
		return m.L3TrackingID
	}
	return ""
}

func (m *Flow) GetParentUUID() string {
	if m != nil {
		return m.ParentUUID
	}
	return ""
}

func (m *Flow) GetNodeTID() string {
	if m != nil {
		return m.NodeTID
	}
	return ""
}

func (m *Flow) GetANodeTID() string {
	if m != nil {
		return m.ANodeTID
	}
	return ""
}

func (m *Flow) GetBNodeTID() string {
	if m != nil {
		return m.BNodeTID
	}
	return ""
}

func init() {
	proto.RegisterType((*FlowLayer)(nil), "flow.FlowLayer")
	proto.RegisterType((*FlowMetric)(nil), "flow.FlowMetric")
	proto.RegisterType((*Flow)(nil), "flow.Flow")
	proto.RegisterEnum("flow.FlowProtocol", FlowProtocol_name, FlowProtocol_value)
}

func init() { proto.RegisterFile("flow/flow.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 491 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0x74, 0x53, 0xcb, 0x8b, 0xd3, 0x40,
	0x18, 0x37, 0x6d, 0xfa, 0xc8, 0xd7, 0xda, 0x86, 0x8f, 0x55, 0x06, 0x11, 0xad, 0x59, 0x90, 0x55,
	0xb0, 0x42, 0x2b, 0x9e, 0xbc, 0x24, 0xbb, 0x15, 0x17, 0x6a, 0x0d, 0xd9, 0x54, 0xbc, 0x8e, 0xd9,
	0xb8, 0x86, 0x96, 0x24, 0x24, 0x03, 0xcb, 0x82, 0xff, 0xb6, 0x77, 0x67, 0xbe, 0xe9, 0x34, 0x75,
	0xad, 0x97, 0x76, 0x7e, 0xcf, 0x79, 0x65, 0x60, 0xfc, 0x63, 0x5b, 0xdc, 0xbe, 0x55, 0x3f, 0xd3,
	0xb2, 0x2a, 0x44, 0x81, 0xb6, 0x1a, 0x7b, 0x37, 0xe0, 0x7c, 0x94, 0xff, 0x4b, 0x7e, 0x97, 0x56,
	0x38, 0x85, 0x7e, 0xa8, 0xb4, 0xa4, 0xd8, 0x32, 0x6b, 0x62, 0x9d, 0x8d, 0x66, 0x38, 0xa5, 0x84,
	0xb2, 0x18, 0x25, 0xda, 0x7b, 0x70, 0x08, 0x96, 0xcf, 0xda, 0xd2, 0xe8, 0x44, 0x96, 0xaf, 0x50,
	0xc0, 0x6c, 0x8d, 0x02, 0x1c, 0x41, 0xeb, 0xf2, 0x82, 0x75, 0x24, 0x6c, 0x47, 0x72, 0xe4, 0xfd,
	0x02, 0x50, 0x2d, 0x9f, 0x53, 0x51, 0x65, 0x09, 0x3e, 0x05, 0xc7, 0x0f, 0x42, 0x9e, 0x6c, 0x52,
	0x51, 0xb3, 0x16, 0x99, 0x1a, 0x02, 0x19, 0xf4, 0xfc, 0x20, 0xb8, 0x13, 0x69, 0x4d, 0xed, 0xed,
	0xc8, 0x40, 0x95, 0x0b, 0x7c, 0x93, 0xb3, 0x75, 0x6e, 0x4f, 0xa8, 0x5c, 0xe0, 0xeb, 0x9c, 0x9e,
	0xd8, 0x40, 0xef, 0xb7, 0x0d, 0xb6, 0x9a, 0x1e, 0x11, 0xec, 0xf5, 0x5a, 0x2e, 0xcc, 0xa2, 0x75,
	0xd2, 0x18, 0x9f, 0x01, 0xd0, 0xfe, 0xeb, 0x90, 0x8b, 0x9f, 0xb4, 0x1a, 0x27, 0x3a, 0x60, 0x70,
	0x02, 0x03, 0xbf, 0x2c, 0xb7, 0x59, 0xc2, 0x45, 0x56, 0xe4, 0xbb, 0x0d, 0x1f, 0x52, 0x78, 0x0a,
	0xf6, 0x32, 0xcb, 0x37, 0xec, 0x44, 0x4a, 0x83, 0xd9, 0xb8, 0x39, 0x34, 0x6a, 0x89, 0x48, 0xc4,
	0x57, 0xd0, 0x5b, 0xa5, 0xe2, 0xb6, 0xa8, 0x36, 0xec, 0xd1, 0x71, 0x9f, 0xd1, 0xf1, 0x0d, 0x38,
	0x71, 0xc5, 0xf3, 0xba, 0x2c, 0x2a, 0xc1, 0x1e, 0x1f, 0x37, 0x37, 0x0e, 0xfc, 0x00, 0xee, 0x92,
	0xd7, 0x62, 0x5d, 0x5e, 0x73, 0x91, 0xea, 0x13, 0x66, 0xcf, 0x29, 0xe5, 0x36, 0x29, 0xcd, 0x47,
	0xff, 0x38, 0xf1, 0x0c, 0xba, 0xbb, 0xcc, 0xe4, 0x3f, 0x99, 0x9d, 0x8e, 0x27, 0xd0, 0xb9, 0x12,
	0x5c, 0x2e, 0x09, 0xe8, 0x74, 0x35, 0x50, 0x47, 0xaa, 0x3a, 0xd9, 0x80, 0x48, 0x1a, 0xcb, 0xce,
	0x71, 0x33, 0x8f, 0xce, 0x0c, 0x49, 0xbe, 0x4f, 0xe3, 0x4b, 0x18, 0x35, 0x14, 0xf5, 0x3c, 0x24,
	0xe3, 0x3d, 0x56, 0x5d, 0x92, 0xdc, 0x70, 0xb2, 0xc9, 0xf2, 0x1b, 0x79, 0x7d, 0x33, 0x7d, 0x49,
	0x0d, 0x83, 0x1e, 0x0c, 0x97, 0xf3, 0x03, 0xc7, 0x9c, 0x1c, 0x7f, 0x71, 0xaa, 0x23, 0xe4, 0x55,
	0x9a, 0x0b, 0xfa, 0x04, 0xba, 0xba, 0xa3, 0x61, 0xd4, 0xf7, 0xb3, 0x2a, 0xae, 0xd3, 0x58, 0x8a,
	0x2f, 0x48, 0x34, 0x10, 0x9f, 0x40, 0xdf, 0x37, 0x92, 0x47, 0xd2, 0x1e, 0x2b, 0x2d, 0x30, 0xda,
	0xa9, 0xd6, 0x0c, 0x7e, 0xfd, 0x0d, 0x86, 0x87, 0x6f, 0x47, 0xbe, 0x91, 0xfe, 0x22, 0xfe, 0xb4,
	0x88, 0x56, 0x8b, 0xd8, 0x7d, 0x80, 0x7d, 0xb0, 0x2f, 0xc3, 0xaf, 0xef, 0x5c, 0x0b, 0x07, 0xd0,
	0x8b, 0xcf, 0xc3, 0xf0, 0x4b, 0x14, 0xbb, 0x2d, 0x05, 0xd6, 0x17, 0x1a, 0xb4, 0x55, 0xe2, 0xea,
	0x3c, 0xd6, 0xc8, 0xde, 0x25, 0xde, 0xbb, 0x9d, 0xef, 0x5d, 0x7a, 0xc5, 0xf3, 0x3f, 0x01, 0x00,
	0x00, 0xff, 0xff, 0x9d, 0xb8, 0xa6, 0xfe, 0xd8, 0x03, 0x00, 0x00,
}
